<template>
  <div class="block-center mt-4 wd-xl">
    <!-- START card-->
    <div class="card card-flat">
      <div class="card-header text-center bg-dark">
        <a href="#">
          <img class="block-center rounded" src="img/logo.png" alt="Image">
        </a>
      </div>
      <div :class="'card-body'+(process ? ' whirl duo' : '')">
        <p class="text-center py-2">LOGIN</p>
        <form :class="'mb-3'" @submit.prevent="validateBeforeSubmit('login')" data-vv-scope="login">
          <!-- EMAIL -->
          <div class="form-group">
            <div class="input-group with-focus">
              <input
                :class="{'form-control border-right-0':true, 'is-invalid': errors.has('login.email')}"
                placeholder="E-mail/CPF"
                v-model="login.email"
                v-validate="'required'"
                type="text"
                name="email"
              >
              <div class="input-group-append">
                <span class="input-group-text text-muted bg-transparent border-left-0">
                  <em class="fa fa-envelope"></em>
                </span>
              </div>
              <span
                v-show="errors.has('login.email')"
                class="invalid-feedback"
              >Informe o e-mail ou CPF</span>
            </div>
          </div>

          <!-- PASSWORD -->
          <div class="form-group">
            <div class="input-group with-focus">
              <input
                :class="{'form-control  border-right-0':true, 'is-invalid': errors.has('login.password')}"
                v-model="login.password"
                v-validate="'required'"
                type="password"
                name="password"
                placeholder="Senha"
              >
              <div class="input-group-append">
                <span class="input-group-text text-muted bg-transparent border-left-0">
                  <em class="fa fa-lock"></em>
                </span>
              </div>
              <span
                v-show="errors.has('login.password')"
                class="invalid-feedback"
              >A senha é requerida</span>
            </div>
          </div>
          <div class="clearfix">
            <label class="text-danger" v-if="error != null">{{error}}</label>
          </div>
          <div class="clearfix">
            <div class="float-left">
              <div class="custom-control custom-checkbox">
                <input
                  type="checkbox"
                  class="custom-control-input"
                  name="rememberme"
                  id="rememberme"
                  v-model="login.rememberme"
                >
                <label class="custom-control-label" for="rememberme">Lembre-me</label>
              </div>
            </div>
            <div class="float-right">
              <router-link class="text-muted" to="/recover">
                <small>Esqueceu a senha?</small>
              </router-link>
            </div>
          </div>
          <button class="btn btn-block btn-primary mt-3" type="submit">Login</button>
        </form>
        <!-- <p class="pt-3 text-center">Cadastrar ?</p>
        <router-link class="btn btn-block btn-secondary" to="/register">Registr-se agora</router-link>-->
      </div>
    </div>
    <!-- END card-->
    <div class="p-3 text-center">
      <span class="mr-2">&copy;</span>
      <span>2018</span>
      <span class="mr-2">-</span>
      <span>Angle</span>
      <br>
      <span>Bootstrap Admin Template</span>
    </div>
  </div>
</template>
<script>
import Vue from "vue";
import VeeValidate from "vee-validate";
import AuthService from "@/domain/auth/AuthService";
import axios from "axios";
import MaskedInput from "vue-text-mask";

Vue.use(VeeValidate, {
  fieldsBagName: "formFields" // fix issue with b-table
});

export default {
  components: {
    MaskedInput
  },
  data() {
    return {
      mask: {
        cpf: [
          /\d/,
          /\d/,
          /\d/,
          ".",
          /\d/,
          /\d/,
          /\d/,
          ".",
          /\d/,
          /\d/,
          /\d/,
          "-",
          /\d/,
          /\d/
        ]
      },
      process: false,
      error: null,
      authService: new AuthService(),
      login: {
        email: "",
        password: "",
        rememberme: false
      }
    };
  },
  methods: {
    validateBeforeSubmit(scope) {
      this.$validator.validateAll(scope).then(result => {
        if (result) {
          // efetuar login
          this.process = true;
          this.authService
            .login(this.login.email, this.login.password)
            .then(response => {
              // resgatar o token de auth
              this.$localStorage.set("token", response.token);
              this.$localStorage.set("user", JSON.stringify(response));
              axios.defaults.headers.common = {
                Authorization: "Bearer " + response.token
              };
              this.$router.push({
                path: "/users"
              });
              this.process = false;
            })
            .catch(err => {
              console.log(JSON.stringify(err));
              if (
                err.response &&
                err.response.data &&
                err.response.data.exception &&
                err.response.data.exception ==
                  "Prettus\\Validator\\Exceptions\\ValidatorException"
              ) {
                // alguma validação deu errado
                for (var key in err.response.data.message) {
                  this.notificationProvider.error(
                    "Verificar " + key,
                    err.response.data.message[key][0]
                  );
                }
              } else if (
                err.response != undefined &&
                err.response.status == 401
              ) {
                //usuario ou senha invalidos
                this.error = "Usuário e/ou senha inválidos";
              } else {
                // ocorreu um erro ao logar
                this.error = "Houve um problema ao efetuar o login";
              }
              this.process = false;
            });
        }
      });
    }
  }
};
</script>
